import type { LwrProxyServerConfig, LwrProxyConfiguration } from './proxy-server.js';
import { LwrProxyServer } from './proxy-server.js';
export declare const DEFAULT_PROXY_PORT = 4000;
export type { LwrProxyConfiguration } from './proxy-server.js';
export { addRemoteProxyMiddleware } from './middleware.js';
/**
 * Creates an Development Proxy Server using the provided `LwrProxyServerConfig` configuration.
 * @param config The configuration for the proxy
 * @returns  LwrProxyServer instance
 */
export declare function createProxyServer(config: LwrProxyServerConfig): LwrProxyServer;
/**
 * Searches for a `_proxy` configuration resource using the following search logic:
 *  - ${rootDir}/${buildDir}/config/_proxy
 *  - ${rootDir}/config/_proxy
 * @param rootDir The root directory of the project
 * @param buildDir The built distribution directory/
 * @returns The found LwrProxyConfiguration object or undefined if no _proxy object could be found.
 */
export declare function findProxyConfiguration(rootDir: string, buildDir?: string): LwrProxyConfiguration | undefined;
//# sourceMappingURL=index.d.ts.map